package java.lang.ref;

import java.util.Map;
import java.util.Arrays;
import java.util.Comparator;
import java.util.HashMap;

final class FinalizerHistogram
{
    FinalizerHistogram() {
    }
    
    static FinalizerHistogram.Entry[] getFinalizerHistogram() {
        HashMap<Object, Object> hashMap = new HashMap();
        Finalizer.getQueue().forEach(reference/* java.lang.ref.Reference, */ -> {
            Object o = reference.get();
            if (o != null) {
                ((FinalizerHistogram.Entry)var_0_07.computeIfAbsent(o.getClass().getName(), FinalizerHistogram.Entry::new)).increment();
            }
            return;
        });
        FinalizerHistogram.Entry[] a = (FinalizerHistogram.Entry[])hashMap.values().toArray(new FinalizerHistogram.Entry[hashMap.size()]);
        Arrays.sort(a, Comparator.comparingInt(FinalizerHistogram.Entry::getInstanceCount).reversed());
        return a;
    }
    
    private static final class Entry
    {
        private int instanceCount;
        private final String className;
        
        int getInstanceCount() {
            return this.instanceCount;
        }
        
        void increment() {
            ++this.instanceCount;
        }
        
        Entry(String className) {
            this.className = className;
        }
    }
}
